## ros-iron-septentrio-gnss-driver 1.3.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(septentrio_gnss_driver)

## Compile as C++17
add_compile_options(-std=c++17)

if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
message(STATUS "Setting build type to Release as none was specified.")
set(CMAKE_BUILD_TYPE "Release" CACHE
    STRING "Choose the type of build." FORCE)
# Set the possible values of build type for cmake-gui
set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS
  "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif()

## ROS dependencies
find_package(ament_cmake REQUIRED)
find_package(rclcpp REQUIRED)
find_package(rclcpp_components REQUIRED)
find_package(rosidl_default_generators REQUIRED)
find_package(diagnostic_msgs REQUIRED)
find_package(nmea_msgs REQUIRED)
find_package(sensor_msgs REQUIRED)
find_package(geometry_msgs REQUIRED)
find_package(gps_msgs REQUIRED)
find_package(nav_msgs REQUIRED)
find_package(tf2 REQUIRED)
find_package(tf2_eigen REQUIRED)
find_package(tf2_geometry_msgs REQUIRED)
find_package(tf2_ros REQUIRED)

## System dependencies are found with CMake's conventions
find_package(Boost REQUIRED COMPONENTS system thread regex chrono)
LIST(APPEND CMAKE_MODULE_PATH "/usr/share/cmake/geographiclib")
find_package(GeographicLib REQUIRED)

## For PCAP file handling
find_library(libpcap_LIBRARIES pcap)
if ("${libpcap_LIBRARIES}" STREQUAL "pcap-NOTFOUND")
    set(libpcap_FOUND FALSE)
else ()
    set(libpcap_FOUND TRUE)
endif ()


## Declare  messages
rosidl_generate_interfaces(${PROJECT_NAME}
   "msg/AIMPlusStatus.msg"
   "msg/BaseVectorCart.msg"
   "msg/BaseVectorGeod.msg"
   "msg/BlockHeader.msg"
   "msg/GALAuthStatus.msg"
   "msg/RFBand.msg"
   "msg/RFStatus.msg"
   "msg/MeasEpoch.msg"
   "msg/MeasEpochChannelType1.msg"
   "msg/MeasEpochChannelType2.msg"
   "msg/PVTCartesian.msg"
   "msg/PVTGeodetic.msg"
   "msg/PosCovCartesian.msg"
   "msg/PosCovGeodetic.msg"
   "msg/ReceiverTime.msg"
   "msg/VelCovCartesian.msg"
   "msg/VelCovGeodetic.msg"
   "msg/AttEuler.msg"
   "msg/AttCovEuler.msg"
   "msg/INSNavCart.msg"
   "msg/INSNavGeod.msg"
   "msg/IMUSetup.msg"
   "msg/VectorInfoCart.msg"
   "msg/VectorInfoGeod.msg"
   "msg/VelSensorSetup.msg"
   "msg/ExtSensorMeas.msg"
   DEPENDENCIES std_msgs
)

set(library_name septentrio_gnss_driver_core)
set(executable_name septentrio_gnss_driver_node)

set(dependencies
   rclcpp
   rclcpp_components
   diagnostic_msgs
   nmea_msgs
   sensor_msgs
   geometry_msgs
   gps_msgs
   nav_msgs
   tf2
   tf2_eigen
   tf2_geometry_msgs
   tf2_ros
)

## shared library
add_library(${library_name} SHARED
  src/septentrio_gnss_driver/communication/communication_core.cpp
  src/septentrio_gnss_driver/communication/message_handler.cpp 
  src/septentrio_gnss_driver/communication/telegram_handler.cpp
  src/septentrio_gnss_driver/crc/crc.cpp
  src/septentrio_gnss_driver/node/main.cpp
  src/septentrio_gnss_driver/node/rosaic_node.cpp
  src/septentrio_gnss_driver/parsers/nmea_parsers/gpgga.cpp 
  src/septentrio_gnss_driver/parsers/nmea_parsers/gprmc.cpp 
  src/septentrio_gnss_driver/parsers/nmea_parsers/gpgsa.cpp 
  src/septentrio_gnss_driver/parsers/nmea_parsers/gpgsv.cpp
  src/septentrio_gnss_driver/parsers/parsing_utilities.cpp 
  src/septentrio_gnss_driver/parsers/string_utilities.cpp 
)
target_include_directories(${library_name} PUBLIC
  "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>"  
  "$<INSTALL_INTERFACE:include>"
)
target_link_libraries(${library_name}
  ${Boost_LIBRARIES}
  pcap
  ${GeographicLib_LIBRARIES}
)
ament_target_dependencies(${library_name}
  ${dependencies}
)

if(${rosidl_cmake_VERSION} VERSION_LESS 2.5.0)
  rosidl_target_interfaces(${library_name}
    ${PROJECT_NAME} "rosidl_typesupport_cpp")
else()
  rosidl_get_typesupport_target(
    cpp_typesupport_target ${PROJECT_NAME} "rosidl_typesupport_cpp")
  target_link_libraries(${library_name} "${cpp_typesupport_target}")
  add_compile_definitions(ROS2_VER_N250)
endif()

## executable
add_executable(${executable_name}
  src/septentrio_gnss_driver/node/main.cpp
)
target_link_libraries(${executable_name}
  ${library_name}
)
ament_target_dependencies(${executable_name}
  ${dependencies}
)

rclcpp_components_register_nodes(${library_name} "rosaic_node::ROSaicNode")

# Testing
find_package(ament_cmake_gtest REQUIRED)
add_subdirectory(test)

# Export Targets
ament_export_targets(${library_name} HAS_LIBRARY_TARGET)
ament_export_dependencies(${dependencies} rosidl_default_runtime)

# installation
install(TARGETS
  ${library_name} EXPORT ${library_name}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

install(TARGETS ${executable_name} EXPORT ${executable_name}
  DESTINATION lib/${PROJECT_NAME}
)

install(DIRECTORY include/
  DESTINATION include/
)

install(DIRECTORY launch
  DESTINATION share/${PROJECT_NAME}
)
install(DIRECTORY config
  DESTINATION share/${PROJECT_NAME}
)

ament_package()

=== test/CMakeLists.txt ===
find_package(ament_cmake_gtest)

ament_add_gtest(test_string_utilities
test_string_utilities.cpp
)

target_link_libraries(test_string_utilities
  ${library_name}
)

ament_add_gtest(test_parsing_utilities
  test_parsing_utilities.cpp
)

target_link_libraries(test_parsing_utilities
  ${library_name}
)

=== debian/changelog ===
ros-iron-septentrio-gnss-driver (1.3.1-3jammy) jammy; urgency=high

  * New Features
    
    Recovery from connection interruption
    
    Add option to bypass configuration of Rx
    
    Add tests
    
    OSNMA
    
    Latency compensation for ROS timestamps
    
    Output of SBf block VelCovCartesian
    
    Support for UDP and TCP via IP server
    
    New VSM handling allows for unknown variances (INS firmware >= 1.4.1)
    
    Add heading angle to GPSFix msg (by diverting dip field, cf. readme)
  * Improvements
    
    Rework IO core and message handling
    * Unified stream processing
    * Internal data queue
    * Prevent message loss in file reading
    
    Add some explanatory warnings for parameter mismatches
    
    Add units to message definitions
  * Fixes
    
    navsatfix for INS
    
    Empty headers
    
    Single antenna receiver setup
  * Preliminary Features
    
    Output of localization and tf in ECEF frame, testing and feedback welcome
  * Commits
    
    Merge pull request #83 from thomasemter/dev/next2
    Update readme
    
    Add expected release dates
    
    Add known issues to readme
    
    Update version
    
    Update readme
    
    Merge pull request #82 from thomasemter/dev/next2
    Fix spelling
    
    Categorize stream params
    
    Add keep alive check for TCP
    
    Fix spelling
    
    Add TCP communication via static IP server
    
    Add units to msgs
    
    Fix spelling
    
    Merge pull request #76 from thomasemter/dev/next2
    upcoming release
    
    Add heading to GPSFix msg
    
    Move constant
    
    Change log level of firmware check
    
    Add improved VSM handling
    
    Change INS in GNSS node detection to auto
    
    Fix invald v_x var case
    
    Refine readme on UDP
    
    Improve server duplicate check
    
    Add more info un UDP configuration
    
    Fix publish check
    
    Add more publishing checks for configured Rx
    
    Add const for max udp packet size
    
    Update readme and changelog
    
    Add device check to node
    
    Fix param name separators
    
    Add checks for IP server duplicates
    
    Add latency compensation to att msgs
    
    Add device check logic
    
    Add UDP params and setup logic
    
    Fix multi msg per packet
    
    Fix localization stamp and tf publishing
    
    Change VSM to be averaged and published with 2 Hz
    
    Change VSM to be averaged and published with 2 Hz
    
    Always publish raw IMU data as indicated
    
    Change to empty fields
    
    Refine diagnostics naming scheme and add trigger to ensure emission of ReceiverSetup
    
    Change diagnostics naming scheme
    
    Add missing new params to gnss.yaml
    
    Expand readme on AIM+
    
    Reformulate readme about ROS and ROS2
    
    Add custom message to report AIM+ status
    
    Catch invalid UTM conversion
    
    Robustify command reset
    
    Add RFStatus diagnostics
    
    Add VelCovCartesian output
    
    Refine Rx type check
    
    Add option for latency compensation
    
    Fix param type misinterpretation
    
    Add OSNMA msg and diagnostics
    
    Update changelog
    
    Refine README and fix compiled message logic
    
    Update changelog
    
    Add warning for configuring INS as GNSS
    
    Add warn log for misconfiguration
    
    Fix pose publishing rate
    
    Fix navsatfix publishing
    
    Make vars const
    
    Merge rework of internal IO handling
    
    Change connection thread
    
    Fix attitude cov flipped twice
    
    Add cov alignment from true north to grid north
    
    Rename meridian convergence and fix sense
    
    Remove obsolete define
    
    Add tests
    
    Rename example launch files so they are found by auto-completion
    
    Merge branch 'dev/ros2' into dev/next2
    
    Fix lat/long in rad
    
    Fix readme concerning ROS 2 distros
    
    Reorder localization msg filling
    
    Update readme
    
    Fix NED to ECEF rotation matrix
    
    Add localization ECEF publishing
    
    Add ecef localization msg
    
    Add local to ecef transforms
    
    Contributors: Thomas Emter, Tibor Dome

 -- Tibor Dome <tibor.doeme@alumni.ethz.ch>  Tue, 05 Jul 2022 23:00:00 -0000

ros-iron-septentrio-gnss-driver (1.2.3-3jammy) jammy; urgency=high

  * New Features
    
    Twist output option
    
    Example config files for GNSS and INS
    
    Get leap seconds from receiver
    
    Firmware check
    
    VSM from odometry or twist ROS messages
    
    Add receiver type in case INS is used in GNSS mode
    
    Add publishing of base vector topics
  * Improvements
    
    Rework RTK corrections parameters and improve flexibility
  * Fixes
    
    /tf not being published without /localization
    
    Twist covariance matrix of localization
    
    Support 5 ms period for IMU explicitly

 -- Septentrio <githubuser@septentrio.com>  Wed, 09 Nov 2022 00:00:00 -0000

ros-iron-septentrio-gnss-driver (1.2.2-3jammy) jammy; urgency=high

  * Fixes
    
    Memory corruption under adverse conditions
  * Commits
    
    Merge pull request #66 from thomasemter/dev/next2
    Fix memory corruption
    
    Fix parameter warnings
    
    Reset buffer size to 16384
    
    Update changelog
    
    Fix memory corruption
    
    Replace maps with unordered_maps
    
    Overload timestamp function
    
    Fix frame ids for INS msgs
    
    Add define to avoid usage of deprecated header
    
    Change readme on gps-msgs packet
    
    Add info on user credentials
    
    Fix spelling in readme
    
    Merge remote-tracking branch 'upstream/ros2' into dev/next2
    
    Add comment for heading from pose
    
    Contributors: Thomas Emter, Tibor Dome

 -- Septentrio <githubuser@septentrio.com>  Tue, 21 Jun 2022 23:00:00 -0000

ros-iron-septentrio-gnss-driver (1.2.1-3jammy) jammy; urgency=high

  * New Features
    
    Add login credentials
    


=== debian/control ===
Source: ros-iron-septentrio-gnss-driver
Section: misc
Priority: optional
Maintainer: Tibor Dome <tibor.doeme@alumni.ethz.ch>
Build-Depends: debhelper (>= 9.0.0), libboost-all-dev, libgeographic-dev, libpcap0.8-dev, ros-iron-ament-cmake, ros-iron-diagnostic-msgs, ros-iron-geometry-msgs, ros-iron-gps-msgs, ros-iron-nav-msgs, ros-iron-nmea-msgs, ros-iron-rclcpp, ros-iron-rclcpp-components, ros-iron-rosidl-default-generators, ros-iron-sensor-msgs, ros-iron-tf2, ros-iron-tf2-eigen, ros-iron-tf2-geometry-msgs, ros-iron-tf2-ros, ros-iron-ros-workspace, ros-iron-rosidl-typesupport-fastrtps-c, ros-iron-rosidl-typesupport-fastrtps-cpp
Homepage: https://github.com/septentrio-gnss/septentrio_gnss_driver
Standards-Version: 3.9.2

Package: ros-iron-septentrio-gnss-driver
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, libgeographic-dev, libpcap0.8-dev, ros-iron-diagnostic-msgs, ros-iron-geometry-msgs, ros-iron-gps-msgs, ros-iron-nav-msgs, ros-iron-nmea-msgs, ros-iron-rclcpp, ros-iron-rclcpp-components, ros-iron-rosidl-default-runtime, ros-iron-sensor-msgs, ros-iron-tf2, ros-iron-tf2-eigen, ros-iron-tf2-geometry-msgs, ros-iron-tf2-ros, ros-iron-ros-workspace
Description: ROSaic: C++ driver for Septentrio's mosaic receivers and beyond

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/iron/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/iron" \
		-DAMENT_PREFIX_PATH="/opt/ros/iron" \
		-DCMAKE_PREFIX_PATH="/opt/ros/iron" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-iron-septentrio-gnss-driver//opt/ros/iron/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_install
